Subject: FW: [pim] Multicast packets not forwarding between subnets (linux)

From: "Vladimir Semencic" <[email-masked]>
Date: Fri, 7 Feb 2003 16:16:36 +0100

Tnx for reply, but the thing that solved my problem is rather strange.

To test routing I've used iperf utility.

As I've said before I've had iperf running on a client that is on one subnet
and server which is on other subnet (and pimd routing packets). Packets were
not forarded although I could see in pimd debug mode that joining to the
group server was sending to was performed ok by client.

Then, when I started another iperf receiver on the host where pimd was
running everything worked and both clients started receving traffic.

Strange enough for me. Any help or hints??

vladi

--------------------------
Your BoxA is not on a subnet of your router - it looks like you might be
able to fix it by
changing the IP address of BoxA from 172.16.2.1 to 172.16.3.2

Cyndi

-----Original Message-----
From: Vladimir Semencic [mailto:[email-masked]]
Sent: Wednesday, January 15, 2003 7:39 AM
To: [email-masked]
Subject: [pim] Multicast packets not forwarding between subnets (linux)

My problem might be trivial for those experienced users. I've found
questions like mine on the net but no answers.

WHAT I WANT TO DO:

Have a Linux Box "boxB1" route multicast traffic from subnet A to subnet B.
No tunnels (for now) are needed.

Subnets configuration:

           ---------                              ---------
    --eth0-| boxA
|-eth1--------------------eth1-|gateway|--eth0------Internet
    |      ---------                              ---------
    | 172.16.2.1     192.168.1.13
    |
    |
    |
    |      ROUTER                   172.16.4.2
    |      ---------                     ---------
    --eth0-| boxB1 |-eth1-----------eth0-| boxB2 |
           ---------                     ---------
      172.16.3.1     172.16.4.1

I've done following.

- installed RH 7.3 on each machine
- compiled kernel with support for multicasting
- have ip_forwarding enabled
- iptables firewall rules ACCEPT everything
- installed routing dameon (tries both mrouted 3.9b3 and
pimd-2.1.0-alpha29.13)
- enabled multicasting on all interfaces

I wanted to test multicasting with iperf, so what I did is:

boxA:    iperf -c 224.0.50.50 -u
boxB2:   iperf -s -B 224.0.50.50 -u

boxB1 is runnung routing dameon.

>From debug info of the (both) routing dameon I can see that both boxes have
joined the group, but no traffic is received on boxB2 (I did try connecting
them directly and that works, but it's not what I want :))) But it shows
that multicasting is enabled at least.

In one document I've read that Multicast routing will not forward a packet
unless the source of the packet passes a reverse path forwarding check. Is
this the reason why I packets are not forwarded or something else I've
missed.

OK. Here are the routing tables for those boxes:
Sorry for the huge message but I'm stuck.

[boxB1 - routing daemon]
------------------------
# route -n
Kernel IP routing table
Destination     Gateway         Genmask         Flags Metric Ref    Use
Iface
172.16.4.0      0.0.0.0         255.255.255.0   U     0      0        0 eth1
172.16.2.0      0.0.0.0         255.255.255.0   U     0      0        0 eth0
172.16.3.0      0.0.0.0         255.255.255.0   U     0      0        0 eth0
127.0.0.0       0.0.0.0         255.0.0.0       U     0      0        0 lo
224.0.0.0       0.0.0.0         240.0.0.0       U     0      0        0 eth0
0.0.0.0         172.16.2.1      0.0.0.0         UG    0      0        0 eth0

# ip a s

1: lo: <LOOPBACK,UP> mtu 16436 qdisc noqueue
    link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
    inet 127.0.0.1/8 brd 127.255.255.255 scope host lo
2: eth0: <BROADCAST,MULTICAST,ALLMULTI,UP> mtu 1500 qdisc pfifo_fast qlen
100
    link/ether 00:30:00:04:b9:34 brd ff:ff:ff:ff:ff:ff
    inet 172.16.3.1/24 brd 172.16.3.255 scope global eth0
3: eth1: <BROADCAST,MULTICAST,ALLMULTI,UP> mtu 1500 qdisc pfifo_fast qlen
100
    link/ether 00:30:00:04:b9:33 brd ff:ff:ff:ff:ff:ff
    inet 172.16.4.1/24 brd 172.16.4.255 scope global eth1
4: gre0@NONE: <NOARP> mtu 1476 qdisc noop
    link/gre 0.0.0.0 brd 0.0.0.0
5: tunl0@NONE: <NOARP> mtu 1480 qdisc noop
    link/ipip 0.0.0.0 brd 0.0.0.0
52: pimreg@NONE: <NOARP,ALLMULTI,UP> mtu 1472 qdisc noqueue
    link/pimreg

# route -n

[boxA - iperf client]
----------------------
Kernel IP routing table
Destination     Gateway         Genmask         Flags Metric Ref    Use
Iface
172.16.2.0      0.0.0.0         255.255.255.0   U     0      0        0 eth0
172.16.3.0      0.0.0.0         255.255.255.0   U     0      0        0 eth0
192.168.1.0     0.0.0.0         255.255.255.0   U     0      0        0 eth1
127.0.0.0       0.0.0.0         255.0.0.0       U     0      0        0 lo
224.0.0.0       0.0.0.0         240.0.0.0       U     0      0        0 eth0
0.0.0.0         172.16.3.1      0.0.0.0         UG    0      0        0 eth0

# ip a s
1: lo: <LOOPBACK,UP> mtu 16436 qdisc noqueue
    link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
    inet 127.0.0.1/8 brd 127.255.255.255 scope host lo
2: eth0: <BROADCAST,MULTICAST,UP> mtu 1500 qdisc pfifo_fast qlen 100
    link/ether 00:30:00:04:b9:cc brd ff:ff:ff:ff:ff:ff
    inet 172.16.2.1/24 brd 172.16.2.255 scope global eth0
3: eth1: <BROADCAST,MULTICAST,UP> mtu 1500 qdisc pfifo_fast qlen 100
    link/ether 00:30:00:04:b9:cb brd ff:ff:ff:ff:ff:ff
    inet 192.168.1.135/24 brd 172.16.2.255 scope global eth1
4: gre0@NONE: <NOARP> mtu 1476 qdisc noop
    link/gre 0.0.0.0 brd 0.0.0.0
6: tunl0@NONE: <NOARP> mtu 1480 qdisc noop
    link/ipip 0.0.0.0 brd 0.0.0.0

[boxB2 - iperf server]
----------------------
# route -n

Kernel IP routing table
Destination     Gateway         Genmask         Flags Metric Ref    Use
Iface
172.16.4.0      0.0.0.0         255.255.255.0   U     0      0        0 eth0
127.0.0.0       0.0.0.0         255.0.0.0       U     0      0        0 lo
224.0.0.0       0.0.0.0         240.0.0.0       U     0      0        0 eth0
0.0.0.0         172.16.4.1      0.0.0.0         UG    0      0        0 eth0

# ip a s

1: lo: <LOOPBACK,UP> mtu 16436 qdisc noqueue
    link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
    inet 127.0.0.1/8 brd 127.255.255.255 scope host lo
2: eth0: <BROADCAST,MULTICAST,UP> mtu 1500 qdisc pfifo_fast qlen 100
    link/ether 00:e0:4c:6c:36:d7 brd ff:ff:ff:ff:ff:ff
    inet 172.16.4.2/24 brd 172.16.4.255 scope global eth0
3: eth1: <BROADCAST,MULTICAST> mtu 1500 qdisc noop qlen 100
    link/ether 00:40:f4:1e:10:bf brd ff:ff:ff:ff:ff:ff

tnx a lot

vladi

_______________________________________________
pim mailing list
[email-masked]
http://catarina.usc.edu/mailman/listinfo/pim

_______________________________________________
pim mailing list
[email-masked]
http://catarina.usc.edu/mailman/listinfo/pim